//May.23.2005
//Tak.Sugawara 
//Generic RAM module 
//
module gen_ram32x32 
   (
	input [31:0] data,
	input wren,//wr
	input [4:0] wraddress,
	input [4:0] rdaddress_a,rdaddress_b,
	input clock,
	output [31:0] qa, qb);

	reg [4:0] address_a_reg,address_b_reg;//address register
	reg [31:0] mem [0:31];//actual memory

	integer i;
//address_a_reg
	always @ (posedge clock) begin
		address_a_reg<=rdaddress_a;
	end

//adress_b_reg
	always @ (posedge clock) begin
		address_b_reg<=rdaddress_b;
	end

//read operation
	assign qa= mem[address_a_reg];
	assign qb= mem[address_b_reg];

//write operatiion
	always @(posedge clock) begin
		if (wren) mem[wraddress]<=data;
	end

	initial begin //Note: YACC needs 0 cleared register at power on
		for (i=0;i<32;i=i+1) begin
			mem[i]=0;
		end
	end

endmodule

